// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'TeePolar.pas' rev: 3.00

#ifndef TeePolarHPP
#define TeePolarHPP
#include <TeCanvas.hpp>
#include <Series.hpp>
#include <Chart.hpp>
#include <TeEngine.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Teepolar
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TCustomPolarSeries;
class PASCALIMPLEMENTATION TCustomPolarSeries : public Series::TCircledSeries 
{
	typedef Series::TCircledSeries inherited;
	
private:
	Teengine::TChartBrush* FBrush;
	bool FCircleLabels;
	Graphics::TFont* FCircleLabelsFont;
	bool FCircleLabelsRot;
	Tecanvas::TChartPen* FCirclePen;
	bool FCloseCircle;
	Tecanvas::TChartPen* FPen;
	Series::TSeriesPointer* FPointer;
	int OldX;
	int OldY;
	int IMaxValuesCount;
	void __fastcall CalcXYPos(int ValueIndex, const double ARadius, int &X, int &Y);
	void __fastcall FillTriangle(const tagPOINT &A, const tagPOINT &B, int Z);
	double __fastcall GetAngleIncrement(void);
	double __fastcall GetRadiusIncrement(void);
	Teengine::TChartValueList* __fastcall GetRadiusValues(void);
	Teengine::TChartValueList* __fastcall GetAngleValues(void);
	bool __fastcall IsFontStored(void);
	bool __fastcall IsRadiusStored(void);
	void __fastcall SetAngleIncrement(const double Value);
	void __fastcall SetAngleValues(Teengine::TChartValueList* Value);
	void __fastcall SetBrush(Teengine::TChartBrush* Value);
	void __fastcall SetCircleLabels(bool Value);
	void __fastcall SetCircleLabelsFont(Graphics::TFont* Value);
	void __fastcall SetCirclePen(Tecanvas::TChartPen* Value);
	void __fastcall SetCloseCircle(bool Value);
	void __fastcall SetLabelsRotated(bool Value);
	void __fastcall SetPen(Tecanvas::TChartPen* Value);
	void __fastcall SetPointer(Series::TSeriesPointer* Value);
	void __fastcall SetRadiusIncrement(const double Value);
	void __fastcall SetRadiusValues(Teengine::TChartValueList* Value);
	
protected:
	virtual void __fastcall SetParentChart(Teengine::TCustomAxisPanel* Value);
	virtual void __fastcall DoBeforeDrawValues(void);
	virtual void __fastcall DrawAllValues(void);
	void __fastcall DrawPolarCircle(int HalfWidth, int HalfHeight, int Z);
	virtual void __fastcall DrawValue(int ValueIndex);
	virtual System::AnsiString __fastcall GetCircleLabel(const double AngleOrIndex);
	void __fastcall LinePrepareCanvas(int ValueIndex);
	virtual void __fastcall SetSeriesColor(Graphics::TColor AColor);
	
public:
	__fastcall virtual TCustomPolarSeries(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomPolarSeries(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual int __fastcall CalcXPos(int ValueIndex);
	virtual int __fastcall CalcYPos(int ValueIndex);
	virtual int __fastcall Clicked(int x, int y);
	virtual void __fastcall DrawLegendShape(int ValueIndex, const Windows::TRect &Rect);
	void __fastcall DrawRing(const double Value, int Z);
	virtual System::AnsiString __fastcall GetEditorClass();
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	__property double AngleIncrement = {read=GetAngleIncrement, write=SetAngleIncrement};
	__property Teengine::TChartValueList* AngleValues = {read=GetAngleValues, write=SetAngleValues};
	__property Teengine::TChartBrush* Brush = {read=FBrush, write=SetBrush};
	__property bool CircleLabels = {read=FCircleLabels, write=SetCircleLabels, default=0};
	__property Graphics::TFont* CircleLabelsFont = {read=FCircleLabelsFont, write=SetCircleLabelsFont, 
		stored=IsFontStored};
	__property bool CircleLabelsRotated = {read=FCircleLabelsRot, write=SetLabelsRotated, default=0};
	__property Tecanvas::TChartPen* CirclePen = {read=FCirclePen, write=SetCirclePen};
	__property bool CloseCircle = {read=FCloseCircle, write=SetCloseCircle, default=1};
	__property Tecanvas::TChartPen* Pen = {read=FPen, write=SetPen};
	__property Series::TSeriesPointer* Pointer = {read=FPointer, write=SetPointer};
	__property double RadiusIncrement = {read=GetRadiusIncrement, write=SetRadiusIncrement};
	__property Teengine::TChartValueList* RadiusValues = {read=GetRadiusValues, write=SetRadiusValues, 
		stored=IsRadiusStored};
};

class DELPHICLASS TPolarSeries;
class PASCALIMPLEMENTATION TPolarSeries : public Teepolar::TCustomPolarSeries 
{
	typedef Teepolar::TCustomPolarSeries inherited;
	
public:
	int __fastcall AddPolar(const double Angle, const double Value, const System::AnsiString ALabel, Graphics::TColor 
		AColor);
	virtual void __fastcall FillSampleValues(int NumValues);
	
__published:
	__property AngleIncrement ;
	__property AngleValues ;
	__property Brush ;
	__property CircleBackColor ;
	__property CircleLabels ;
	__property CircleLabelsFont ;
	__property CircleLabelsRotated ;
	__property CirclePen ;
	__property CloseCircle ;
	__property Pen ;
	__property Pointer ;
	__property RadiusIncrement ;
	__property RadiusValues ;
	__property RotationAngle ;
public:
	/* TCustomPolarSeries.Create */ __fastcall virtual TPolarSeries(Classes::TComponent* AOwner) : Teepolar::
		TCustomPolarSeries(AOwner) { }
	/* TCustomPolarSeries.Destroy */ __fastcall virtual ~TPolarSeries(void) { }
	
};

class DELPHICLASS TRadarSeries;
class PASCALIMPLEMENTATION TRadarSeries : public Teepolar::TCustomPolarSeries 
{
	typedef Teepolar::TCustomPolarSeries inherited;
	
protected:
	virtual void __fastcall DoBeforeDrawChart(void);
	virtual System::AnsiString __fastcall GetCircleLabel(const double AngleOrIndex);
	
public:
	virtual void __fastcall FillSampleValues(int NumValues);
	virtual void __fastcall PrepareForGallery(bool IsEnabled);
	
__published:
	__property Brush ;
	__property CircleBackColor ;
	__property CircleLabels ;
	__property CircleLabelsFont ;
	__property CircleLabelsRotated ;
	__property CirclePen ;
	__property CloseCircle ;
	__property Pen ;
	__property Pointer ;
	__property RadiusIncrement ;
	__property RadiusValues ;
public:
	/* TCustomPolarSeries.Create */ __fastcall virtual TRadarSeries(Classes::TComponent* AOwner) : Teepolar::
		TCustomPolarSeries(AOwner) { }
	/* TCustomPolarSeries.Destroy */ __fastcall virtual ~TRadarSeries(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE char TeePolarDegreeSymbol;

}	/* namespace Teepolar */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Teepolar;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// TeePolar
