//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdlib.h"
#include "TeeShape.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TeeComma"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void TForm1::AddShape(int Col, int Row, const String AText,
  TColor AColor, TAlignment AAlign, TFont* AFont)
{
  TChartShape* AShape = new TChartShape(this);
  AShape->X0 = Col * 10;
  AShape->X1 = AShape->X0 + 10;
  AShape->Y0 = Row * 10;
  AShape->Y1 = AShape->Y0 + 10;
  AShape->Style = chasRectangle;
  AShape->Text->Clear();
  AShape->Text->Add(AText);
  AShape->Title = "Col" + String(Col) + "_Row" + String(Row);
  AShape->SeriesColor = AColor;
  AShape->Alignment = AAlign;
  AShape->Font = AFont;
  AShape->ParentChart = Chart1;
  Chart1->ExchangeSeries(0, AShape->ParentChart->SeriesCount() - 1);
}

void __fastcall TForm1::Table1AfterOpen(TDataSet *DataSet)
{
  int Row, Col;
  Chart1->LeftAxis->Inverted = true;
  Chart1->ApplyZOrder = false;
  Chart1->View3D = true;
  Chart1->View3DOptions->Rotation = 360;
  Chart1->View3DOptions->Elevation = 360;
  Table1->DisableControls();
  Table1->First();
  for (Col=0;Col<DBGrid1->Columns->Count;Col++)
    AddShape(Col, -1,
      DBGrid1->Columns->Items[Col]->Title->Caption,
      DBGrid1->Columns->Items[Col]->Title->Color,
      DBGrid1->Columns->Items[Col]->Title->Alignment,
      DBGrid1->Columns->Items[Col]->Title->Font);
  for (Row=0;Row<Table1->RecordCount;Row++) {
    for (Col=0;Col<DBGrid1->Columns->Count;Col++)
      AddShape(Col, Row, DBGrid1->Columns->Items[Col]->Field->DisplayText,
        DBGrid1->Columns->Items[Col]->Color,
        DBGrid1->Columns->Items[Col]->Alignment,
        DBGrid1->Columns->Items[Col]->Font);
    Table1->Next();
  }
  ComboBox1->ItemIndex = 0;
  Table1->EnableControls();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  Chart1->ApplyZOrder = CheckBox1->Checked;
  Chart1->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
  for (int i=0;i<Chart1->SeriesCount();i++) {
    TChartShape* cs = dynamic_cast<TChartShape*>(Chart1->Series[i]);
    switch (ComboBox1->ItemIndex) {
      case 0: cs->Style = chasRectangle; break;
      case 1: cs->Style = chasCircle; break;
      case 2: cs->Style = chasCube; break;
      case 3: cs->Style = TChartShapeStyle(random(14)); break;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
  Chart1->AxisVisible = CheckBox2->Checked;
}
//---------------------------------------------------------------------------
