//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "stdlib.h"
#include "math.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TeeComma"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::CheckColors()
{
  const TColor NoColor = clWhite;
  TColor tmp;
  Series1->ColorEachPoint = CheckColor->Checked;
  if (!CheckColor->Checked)
    Series1->SeriesColor = NoColor;
  Series6->ColorEachPoint = CheckColor->Checked;
  if (!CheckColor->Checked)
    Series6->SeriesColor = NoColor;
  if (CheckColor->Checked)
    tmp = clBlue;
  else tmp = NoColor;
  Series8->SeriesColor = tmp;
  Chart1->Gradient->Visible = CheckColor->Checked;
}

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  DeltaRot = 2;
  DeltaElev = 5;
  DeltaZoom = 1;
  Chart1->View3DOptions->Elevation = 350;
  for (int i=1;i<7;i++) {
    TBarSeries* bs = dynamic_cast<TBarSeries*>(Chart1->Series[i - 1]);
    bs->BarWidthPercent = 25;
  }
  for (int i=1;i<7;i++)
    Series1->AddXY(i, 100, "", clTeeColor);
  Series2->AddXY(1, 100, "", clWhite);
  Series2->AddXY(6, 100, "", clWhite);
  Series3->AddXY(1, 100, "", clWhite);
  Series3->AddXY(6, 100, "", clWhite);
  Series4->AddXY(1, 100, "", clWhite);
  Series4->AddXY(6, 100, "", clWhite);
  Series5->AddXY(1, 100, "", clWhite);
  Series5->AddXY(6, 100, "", clWhite);
  for (int i=1;i<7;i++)
    Series6->AddXY(i, 100, "", clTeeColor);
  Series8->X0 = 1;
  Series8->X1 = 6;
  Series8->Y0 = 100;
  Series8->Y1 = 120;
  Series7->X0 = 1;
  Series7->X1 = 6;
  Series7->Y0 = 120;
  Series7->Y1 = 140;
  CheckColors();
  CheckBox4Click(this);
  CBBarStyle->ItemIndex = 3;
  CBBarStyleChange(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Series7BeforeDrawValues(TObject *Sender)
{
  TChartShape* cs = dynamic_cast<TChartShape*>(Sender);
  cs->StartZ = Chart1->DepthAxis->CalcYPosValue(2);
  cs->EndZ = Chart1->DepthAxis->CalcYPosValue(Chart1->MaxZOrder);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Series6BeforeDrawValues(TObject *Sender)
{
  TBarSeries* bs = dynamic_cast<TBarSeries*>(Sender);
  int Dif = floor(((bs->EndZ - bs->StartZ) * 25.0 / 100.0) + .5);
  bs->StartZ = bs->StartZ  +  Dif;
  bs->EndZ = bs->EndZ - Dif;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Series1AfterDrawValues(TObject *Sender)
{
  TRect tmp;
  for (int i=1;i<5;i++) {
    tmp.TopLeft = Chart1->Canvas->Calculate3DPosition(
      Chart1->ChartXCenter + 20 * i - 40, Chart1->ChartYCenter + 20 * i - 40, Chart1->Width3D / 2);
    tmp.BottomRight = Chart1->Canvas->Calculate3DPosition(
      Chart1->ChartXCenter + 20 * i + 40, Chart1->ChartYCenter + 20 * i + 40, Chart1->Width3D / 2);
    Chart1->Canvas->StretchDraw(tmp, Image1->Picture->Graphic);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   Timer1->Enabled = CheckBox1->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  int MinAngle;
  if (Chart1->Canvas->SupportsFullRotation)
    MinAngle = 0;
  else
    MinAngle = 270;
  Chart1->View3DOptions->Rotation += DeltaRot;
  if (Chart1->Canvas->SupportsFullRotation) {
    if (Chart1->View3DOptions->Rotation > 360)
      Chart1->View3DOptions->Rotation -= 360;
    else
      if (Chart1->View3DOptions->Rotation < 0)
        Chart1->View3DOptions->Rotation += 360;
  }
  else {
    if (Chart1->View3DOptions->Rotation > 360 ||
        Chart1->View3DOptions->Rotation < MinAngle) {
      DeltaRot = -DeltaRot;
      Chart1->View3DOptions->Rotation += DeltaRot;
      if (DeltaRot > 0)
        DeltaRot = 1 + random(3);
      else
        DeltaRot = -(1 + random(3));
    }
    Chart1->View3DOptions->Elevation += DeltaElev;
    if (Chart1->Canvas->SupportsFullRotation) {
      if (Chart1->View3DOptions->Elevation > 360)
        Chart1->View3DOptions->Elevation -= 360;
      else
        if (Chart1->View3DOptions->Elevation < 0)
          Chart1->View3DOptions->Elevation += 360;
    }
    else
      if (Chart1->View3DOptions->Elevation > 360 ||
          Chart1->View3DOptions->Elevation < MinAngle + 60) {
        DeltaElev = -DeltaElev;
        if (Chart1->View3DOptions->Elevation > 360)
          Chart1->View3DOptions->Elevation = MaxLong(360, Chart1->View3DOptions->Elevation + DeltaElev);
        else
          Chart1->View3DOptions->Elevation = MinLong(MinAngle + 60, Chart1->View3DOptions->Elevation + DeltaElev);
        if (DeltaElev > 0)
          DeltaElev = 1 + random(5);
        else
          DeltaElev = -(1 + random(5));
      }

    Chart1->View3DOptions->Zoom +=
      floor((DeltaZoom * Chart1->View3DOptions->Zoom / 100.0) + .5);
    if (Chart1->View3DOptions->Zoom > 150 ||
        Chart1->View3DOptions->Zoom < 40) {
      DeltaZoom = -DeltaZoom;
      Chart1->View3DOptions->Zoom +=
        floor((DeltaZoom * Chart1->View3DOptions->Zoom / 100.0) + .5);
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox4Click(TObject *Sender)
{
  Chart1->View3DWalls = CheckBox4->Checked;
  if (CheckBox4->Checked)
    Chart1->BackWall->Brush->Style = bsSolid;
  else
    Chart1->BackWall->Brush->Style = bsClear;
  Chart1->BackWall->Pen->Visible = CheckBox4->Checked;
  Chart1->LeftWall->Brush->Style = Chart1->BackWall->Brush->Style;
  Chart1->LeftWall->Pen->Visible = CheckBox4->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckColorClick(TObject *Sender)
{
  CheckColors();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
  Chart1->AxisVisible  = CheckBox3->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CBBarStyleChange(TObject *Sender)
{
  for (int i=1;i<7;i++) {
    TBarSeries* bs = dynamic_cast<TBarSeries*>(Chart1->Series[i - 1]);
    bs->BarStyle = (TBarStyle)CBBarStyle->ItemIndex;
    bs->BarPen->Visible = bs->BarStyle != bsCilinder;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  Timer1->Enabled = False;
  Close();
}
//---------------------------------------------------------------------------

