//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

String TForm1::GetAxisName(TCustomChartAxis* Axis)
{
  String result;
  if (Axis->IsDepthAxis)
    result = "Depth";
  else if (Axis->Horizontal)
    if (Axis->OtherSide)
      result = "Top";
    else
      result = "Bottom";
  else
    if (Axis->OtherSide)
      result = "Right";
    else
      result = "Left";
  return result;
}

void __fastcall TForm1::DBChart1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  TChartClickedPart Part;
  DBChart1->CalcClickedPart(Point(X,Y), Part);
  switch (Part.Part) {
    case cpNone :      Hint = ""; break;
    case cpLegend :    Hint = "Legend"; break;
    case cpAxis :      Hint = GetAxisName(Part.AAxis) + " Axis"; break;
    case cpSeries : {
      if (Part.ASeries->Title == "")
        Hint = Part.ASeries->Name;
      else
        Hint = Part.ASeries->Title;
      Hint = Hint + " " + Part.ASeries->ValueMarkText[Part.PointIndex];
      break;
    }
    case cpTitle :     Hint = "Title"; break;
    case cpFoot :      Hint = "Foot"; break;
    case cpChartRect : Hint = "Chart"; break;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Application->HintPause = 0;

  /* Properties used:

    Series1->DataSource  =  DataSource1 ;
    Series1->YValues->ValueSource  =  "size;weight";
  */
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DataSource1DataChange(TObject *Sender,
      TField *Field)
{
  DBChart1->Title->Text->Clear();
  DBChart1->Title->Text->Add(Table1->FieldByName("Name")->AsString);
}
//---------------------------------------------------------------------------
